package cn.superdesk.uniorder.dao.entity.statistics.prayable;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class StPayableDetailDataEntityExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public StPayableDetailDataEntityExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andCreditIdIsNull() {
            addCriterion("credit_id is null");
            return (Criteria) this;
        }

        public Criteria andCreditIdIsNotNull() {
            addCriterion("credit_id is not null");
            return (Criteria) this;
        }

        public Criteria andCreditIdEqualTo(Long value) {
            addCriterion("credit_id =", value, "creditId");
            return (Criteria) this;
        }

        public Criteria andCreditIdNotEqualTo(Long value) {
            addCriterion("credit_id <>", value, "creditId");
            return (Criteria) this;
        }

        public Criteria andCreditIdGreaterThan(Long value) {
            addCriterion("credit_id >", value, "creditId");
            return (Criteria) this;
        }

        public Criteria andCreditIdGreaterThanOrEqualTo(Long value) {
            addCriterion("credit_id >=", value, "creditId");
            return (Criteria) this;
        }

        public Criteria andCreditIdLessThan(Long value) {
            addCriterion("credit_id <", value, "creditId");
            return (Criteria) this;
        }

        public Criteria andCreditIdLessThanOrEqualTo(Long value) {
            addCriterion("credit_id <=", value, "creditId");
            return (Criteria) this;
        }

        public Criteria andCreditIdIn(List<Long> values) {
            addCriterion("credit_id in", values, "creditId");
            return (Criteria) this;
        }

        public Criteria andCreditIdNotIn(List<Long> values) {
            addCriterion("credit_id not in", values, "creditId");
            return (Criteria) this;
        }

        public Criteria andCreditIdBetween(Long value1, Long value2) {
            addCriterion("credit_id between", value1, value2, "creditId");
            return (Criteria) this;
        }

        public Criteria andCreditIdNotBetween(Long value1, Long value2) {
            addCriterion("credit_id not between", value1, value2, "creditId");
            return (Criteria) this;
        }

        public Criteria andSettlementIdIsNull() {
            addCriterion("settlement_id is null");
            return (Criteria) this;
        }

        public Criteria andSettlementIdIsNotNull() {
            addCriterion("settlement_id is not null");
            return (Criteria) this;
        }

        public Criteria andSettlementIdEqualTo(Long value) {
            addCriterion("settlement_id =", value, "settlementId");
            return (Criteria) this;
        }

        public Criteria andSettlementIdNotEqualTo(Long value) {
            addCriterion("settlement_id <>", value, "settlementId");
            return (Criteria) this;
        }

        public Criteria andSettlementIdGreaterThan(Long value) {
            addCriterion("settlement_id >", value, "settlementId");
            return (Criteria) this;
        }

        public Criteria andSettlementIdGreaterThanOrEqualTo(Long value) {
            addCriterion("settlement_id >=", value, "settlementId");
            return (Criteria) this;
        }

        public Criteria andSettlementIdLessThan(Long value) {
            addCriterion("settlement_id <", value, "settlementId");
            return (Criteria) this;
        }

        public Criteria andSettlementIdLessThanOrEqualTo(Long value) {
            addCriterion("settlement_id <=", value, "settlementId");
            return (Criteria) this;
        }

        public Criteria andSettlementIdIn(List<Long> values) {
            addCriterion("settlement_id in", values, "settlementId");
            return (Criteria) this;
        }

        public Criteria andSettlementIdNotIn(List<Long> values) {
            addCriterion("settlement_id not in", values, "settlementId");
            return (Criteria) this;
        }

        public Criteria andSettlementIdBetween(Long value1, Long value2) {
            addCriterion("settlement_id between", value1, value2, "settlementId");
            return (Criteria) this;
        }

        public Criteria andSettlementIdNotBetween(Long value1, Long value2) {
            addCriterion("settlement_id not between", value1, value2, "settlementId");
            return (Criteria) this;
        }

        public Criteria andSettlementNameIsNull() {
            addCriterion("settlement_name is null");
            return (Criteria) this;
        }

        public Criteria andSettlementNameIsNotNull() {
            addCriterion("settlement_name is not null");
            return (Criteria) this;
        }

        public Criteria andSettlementNameEqualTo(String value) {
            addCriterion("settlement_name =", value, "settlementName");
            return (Criteria) this;
        }

        public Criteria andSettlementNameNotEqualTo(String value) {
            addCriterion("settlement_name <>", value, "settlementName");
            return (Criteria) this;
        }

        public Criteria andSettlementNameGreaterThan(String value) {
            addCriterion("settlement_name >", value, "settlementName");
            return (Criteria) this;
        }

        public Criteria andSettlementNameGreaterThanOrEqualTo(String value) {
            addCriterion("settlement_name >=", value, "settlementName");
            return (Criteria) this;
        }

        public Criteria andSettlementNameLessThan(String value) {
            addCriterion("settlement_name <", value, "settlementName");
            return (Criteria) this;
        }

        public Criteria andSettlementNameLessThanOrEqualTo(String value) {
            addCriterion("settlement_name <=", value, "settlementName");
            return (Criteria) this;
        }

        public Criteria andSettlementNameLike(String value) {
            addCriterion("settlement_name like", value, "settlementName");
            return (Criteria) this;
        }

        public Criteria andSettlementNameNotLike(String value) {
            addCriterion("settlement_name not like", value, "settlementName");
            return (Criteria) this;
        }

        public Criteria andSettlementNameIn(List<String> values) {
            addCriterion("settlement_name in", values, "settlementName");
            return (Criteria) this;
        }

        public Criteria andSettlementNameNotIn(List<String> values) {
            addCriterion("settlement_name not in", values, "settlementName");
            return (Criteria) this;
        }

        public Criteria andSettlementNameBetween(String value1, String value2) {
            addCriterion("settlement_name between", value1, value2, "settlementName");
            return (Criteria) this;
        }

        public Criteria andSettlementNameNotBetween(String value1, String value2) {
            addCriterion("settlement_name not between", value1, value2, "settlementName");
            return (Criteria) this;
        }

        public Criteria andOrderSnIsNull() {
            addCriterion("order_sn is null");
            return (Criteria) this;
        }

        public Criteria andOrderSnIsNotNull() {
            addCriterion("order_sn is not null");
            return (Criteria) this;
        }

        public Criteria andOrderSnEqualTo(String value) {
            addCriterion("order_sn =", value, "orderSn");
            return (Criteria) this;
        }

        public Criteria andOrderSnNotEqualTo(String value) {
            addCriterion("order_sn <>", value, "orderSn");
            return (Criteria) this;
        }

        public Criteria andOrderSnGreaterThan(String value) {
            addCriterion("order_sn >", value, "orderSn");
            return (Criteria) this;
        }

        public Criteria andOrderSnGreaterThanOrEqualTo(String value) {
            addCriterion("order_sn >=", value, "orderSn");
            return (Criteria) this;
        }

        public Criteria andOrderSnLessThan(String value) {
            addCriterion("order_sn <", value, "orderSn");
            return (Criteria) this;
        }

        public Criteria andOrderSnLessThanOrEqualTo(String value) {
            addCriterion("order_sn <=", value, "orderSn");
            return (Criteria) this;
        }

        public Criteria andOrderSnLike(String value) {
            addCriterion("order_sn like", value, "orderSn");
            return (Criteria) this;
        }

        public Criteria andOrderSnNotLike(String value) {
            addCriterion("order_sn not like", value, "orderSn");
            return (Criteria) this;
        }

        public Criteria andOrderSnIn(List<String> values) {
            addCriterion("order_sn in", values, "orderSn");
            return (Criteria) this;
        }

        public Criteria andOrderSnNotIn(List<String> values) {
            addCriterion("order_sn not in", values, "orderSn");
            return (Criteria) this;
        }

        public Criteria andOrderSnBetween(String value1, String value2) {
            addCriterion("order_sn between", value1, value2, "orderSn");
            return (Criteria) this;
        }

        public Criteria andOrderSnNotBetween(String value1, String value2) {
            addCriterion("order_sn not between", value1, value2, "orderSn");
            return (Criteria) this;
        }

        public Criteria andCreditNoIsNull() {
            addCriterion("credit_no is null");
            return (Criteria) this;
        }

        public Criteria andCreditNoIsNotNull() {
            addCriterion("credit_no is not null");
            return (Criteria) this;
        }

        public Criteria andCreditNoEqualTo(String value) {
            addCriterion("credit_no =", value, "creditNo");
            return (Criteria) this;
        }

        public Criteria andCreditNoNotEqualTo(String value) {
            addCriterion("credit_no <>", value, "creditNo");
            return (Criteria) this;
        }

        public Criteria andCreditNoGreaterThan(String value) {
            addCriterion("credit_no >", value, "creditNo");
            return (Criteria) this;
        }

        public Criteria andCreditNoGreaterThanOrEqualTo(String value) {
            addCriterion("credit_no >=", value, "creditNo");
            return (Criteria) this;
        }

        public Criteria andCreditNoLessThan(String value) {
            addCriterion("credit_no <", value, "creditNo");
            return (Criteria) this;
        }

        public Criteria andCreditNoLessThanOrEqualTo(String value) {
            addCriterion("credit_no <=", value, "creditNo");
            return (Criteria) this;
        }

        public Criteria andCreditNoLike(String value) {
            addCriterion("credit_no like", value, "creditNo");
            return (Criteria) this;
        }

        public Criteria andCreditNoNotLike(String value) {
            addCriterion("credit_no not like", value, "creditNo");
            return (Criteria) this;
        }

        public Criteria andCreditNoIn(List<String> values) {
            addCriterion("credit_no in", values, "creditNo");
            return (Criteria) this;
        }

        public Criteria andCreditNoNotIn(List<String> values) {
            addCriterion("credit_no not in", values, "creditNo");
            return (Criteria) this;
        }

        public Criteria andCreditNoBetween(String value1, String value2) {
            addCriterion("credit_no between", value1, value2, "creditNo");
            return (Criteria) this;
        }

        public Criteria andCreditNoNotBetween(String value1, String value2) {
            addCriterion("credit_no not between", value1, value2, "creditNo");
            return (Criteria) this;
        }

        public Criteria andRefundOrderSnIsNull() {
            addCriterion("refund_order_sn is null");
            return (Criteria) this;
        }

        public Criteria andRefundOrderSnIsNotNull() {
            addCriterion("refund_order_sn is not null");
            return (Criteria) this;
        }

        public Criteria andRefundOrderSnEqualTo(String value) {
            addCriterion("refund_order_sn =", value, "refundOrderSn");
            return (Criteria) this;
        }

        public Criteria andRefundOrderSnNotEqualTo(String value) {
            addCriterion("refund_order_sn <>", value, "refundOrderSn");
            return (Criteria) this;
        }

        public Criteria andRefundOrderSnGreaterThan(String value) {
            addCriterion("refund_order_sn >", value, "refundOrderSn");
            return (Criteria) this;
        }

        public Criteria andRefundOrderSnGreaterThanOrEqualTo(String value) {
            addCriterion("refund_order_sn >=", value, "refundOrderSn");
            return (Criteria) this;
        }

        public Criteria andRefundOrderSnLessThan(String value) {
            addCriterion("refund_order_sn <", value, "refundOrderSn");
            return (Criteria) this;
        }

        public Criteria andRefundOrderSnLessThanOrEqualTo(String value) {
            addCriterion("refund_order_sn <=", value, "refundOrderSn");
            return (Criteria) this;
        }

        public Criteria andRefundOrderSnLike(String value) {
            addCriterion("refund_order_sn like", value, "refundOrderSn");
            return (Criteria) this;
        }

        public Criteria andRefundOrderSnNotLike(String value) {
            addCriterion("refund_order_sn not like", value, "refundOrderSn");
            return (Criteria) this;
        }

        public Criteria andRefundOrderSnIn(List<String> values) {
            addCriterion("refund_order_sn in", values, "refundOrderSn");
            return (Criteria) this;
        }

        public Criteria andRefundOrderSnNotIn(List<String> values) {
            addCriterion("refund_order_sn not in", values, "refundOrderSn");
            return (Criteria) this;
        }

        public Criteria andRefundOrderSnBetween(String value1, String value2) {
            addCriterion("refund_order_sn between", value1, value2, "refundOrderSn");
            return (Criteria) this;
        }

        public Criteria andRefundOrderSnNotBetween(String value1, String value2) {
            addCriterion("refund_order_sn not between", value1, value2, "refundOrderSn");
            return (Criteria) this;
        }

        public Criteria andServiceNoIsNull() {
            addCriterion("service_no is null");
            return (Criteria) this;
        }

        public Criteria andServiceNoIsNotNull() {
            addCriterion("service_no is not null");
            return (Criteria) this;
        }

        public Criteria andServiceNoEqualTo(String value) {
            addCriterion("service_no =", value, "serviceNo");
            return (Criteria) this;
        }

        public Criteria andServiceNoNotEqualTo(String value) {
            addCriterion("service_no <>", value, "serviceNo");
            return (Criteria) this;
        }

        public Criteria andServiceNoGreaterThan(String value) {
            addCriterion("service_no >", value, "serviceNo");
            return (Criteria) this;
        }

        public Criteria andServiceNoGreaterThanOrEqualTo(String value) {
            addCriterion("service_no >=", value, "serviceNo");
            return (Criteria) this;
        }

        public Criteria andServiceNoLessThan(String value) {
            addCriterion("service_no <", value, "serviceNo");
            return (Criteria) this;
        }

        public Criteria andServiceNoLessThanOrEqualTo(String value) {
            addCriterion("service_no <=", value, "serviceNo");
            return (Criteria) this;
        }

        public Criteria andServiceNoLike(String value) {
            addCriterion("service_no like", value, "serviceNo");
            return (Criteria) this;
        }

        public Criteria andServiceNoNotLike(String value) {
            addCriterion("service_no not like", value, "serviceNo");
            return (Criteria) this;
        }

        public Criteria andServiceNoIn(List<String> values) {
            addCriterion("service_no in", values, "serviceNo");
            return (Criteria) this;
        }

        public Criteria andServiceNoNotIn(List<String> values) {
            addCriterion("service_no not in", values, "serviceNo");
            return (Criteria) this;
        }

        public Criteria andServiceNoBetween(String value1, String value2) {
            addCriterion("service_no between", value1, value2, "serviceNo");
            return (Criteria) this;
        }

        public Criteria andServiceNoNotBetween(String value1, String value2) {
            addCriterion("service_no not between", value1, value2, "serviceNo");
            return (Criteria) this;
        }

        public Criteria andServiceNoNameIsNull() {
            addCriterion("service_no_name is null");
            return (Criteria) this;
        }

        public Criteria andServiceNoNameIsNotNull() {
            addCriterion("service_no_name is not null");
            return (Criteria) this;
        }

        public Criteria andServiceNoNameEqualTo(String value) {
            addCriterion("service_no_name =", value, "serviceNoName");
            return (Criteria) this;
        }

        public Criteria andServiceNoNameNotEqualTo(String value) {
            addCriterion("service_no_name <>", value, "serviceNoName");
            return (Criteria) this;
        }

        public Criteria andServiceNoNameGreaterThan(String value) {
            addCriterion("service_no_name >", value, "serviceNoName");
            return (Criteria) this;
        }

        public Criteria andServiceNoNameGreaterThanOrEqualTo(String value) {
            addCriterion("service_no_name >=", value, "serviceNoName");
            return (Criteria) this;
        }

        public Criteria andServiceNoNameLessThan(String value) {
            addCriterion("service_no_name <", value, "serviceNoName");
            return (Criteria) this;
        }

        public Criteria andServiceNoNameLessThanOrEqualTo(String value) {
            addCriterion("service_no_name <=", value, "serviceNoName");
            return (Criteria) this;
        }

        public Criteria andServiceNoNameLike(String value) {
            addCriterion("service_no_name like", value, "serviceNoName");
            return (Criteria) this;
        }

        public Criteria andServiceNoNameNotLike(String value) {
            addCriterion("service_no_name not like", value, "serviceNoName");
            return (Criteria) this;
        }

        public Criteria andServiceNoNameIn(List<String> values) {
            addCriterion("service_no_name in", values, "serviceNoName");
            return (Criteria) this;
        }

        public Criteria andServiceNoNameNotIn(List<String> values) {
            addCriterion("service_no_name not in", values, "serviceNoName");
            return (Criteria) this;
        }

        public Criteria andServiceNoNameBetween(String value1, String value2) {
            addCriterion("service_no_name between", value1, value2, "serviceNoName");
            return (Criteria) this;
        }

        public Criteria andServiceNoNameNotBetween(String value1, String value2) {
            addCriterion("service_no_name not between", value1, value2, "serviceNoName");
            return (Criteria) this;
        }

        public Criteria andOrderStateIsNull() {
            addCriterion("order_state is null");
            return (Criteria) this;
        }

        public Criteria andOrderStateIsNotNull() {
            addCriterion("order_state is not null");
            return (Criteria) this;
        }

        public Criteria andOrderStateEqualTo(Byte value) {
            addCriterion("order_state =", value, "orderState");
            return (Criteria) this;
        }

        public Criteria andOrderStateNotEqualTo(Byte value) {
            addCriterion("order_state <>", value, "orderState");
            return (Criteria) this;
        }

        public Criteria andOrderStateGreaterThan(Byte value) {
            addCriterion("order_state >", value, "orderState");
            return (Criteria) this;
        }

        public Criteria andOrderStateGreaterThanOrEqualTo(Byte value) {
            addCriterion("order_state >=", value, "orderState");
            return (Criteria) this;
        }

        public Criteria andOrderStateLessThan(Byte value) {
            addCriterion("order_state <", value, "orderState");
            return (Criteria) this;
        }

        public Criteria andOrderStateLessThanOrEqualTo(Byte value) {
            addCriterion("order_state <=", value, "orderState");
            return (Criteria) this;
        }

        public Criteria andOrderStateIn(List<Byte> values) {
            addCriterion("order_state in", values, "orderState");
            return (Criteria) this;
        }

        public Criteria andOrderStateNotIn(List<Byte> values) {
            addCriterion("order_state not in", values, "orderState");
            return (Criteria) this;
        }

        public Criteria andOrderStateBetween(Byte value1, Byte value2) {
            addCriterion("order_state between", value1, value2, "orderState");
            return (Criteria) this;
        }

        public Criteria andOrderStateNotBetween(Byte value1, Byte value2) {
            addCriterion("order_state not between", value1, value2, "orderState");
            return (Criteria) this;
        }

        public Criteria andOrderStateNameIsNull() {
            addCriterion("order_state_name is null");
            return (Criteria) this;
        }

        public Criteria andOrderStateNameIsNotNull() {
            addCriterion("order_state_name is not null");
            return (Criteria) this;
        }

        public Criteria andOrderStateNameEqualTo(String value) {
            addCriterion("order_state_name =", value, "orderStateName");
            return (Criteria) this;
        }

        public Criteria andOrderStateNameNotEqualTo(String value) {
            addCriterion("order_state_name <>", value, "orderStateName");
            return (Criteria) this;
        }

        public Criteria andOrderStateNameGreaterThan(String value) {
            addCriterion("order_state_name >", value, "orderStateName");
            return (Criteria) this;
        }

        public Criteria andOrderStateNameGreaterThanOrEqualTo(String value) {
            addCriterion("order_state_name >=", value, "orderStateName");
            return (Criteria) this;
        }

        public Criteria andOrderStateNameLessThan(String value) {
            addCriterion("order_state_name <", value, "orderStateName");
            return (Criteria) this;
        }

        public Criteria andOrderStateNameLessThanOrEqualTo(String value) {
            addCriterion("order_state_name <=", value, "orderStateName");
            return (Criteria) this;
        }

        public Criteria andOrderStateNameLike(String value) {
            addCriterion("order_state_name like", value, "orderStateName");
            return (Criteria) this;
        }

        public Criteria andOrderStateNameNotLike(String value) {
            addCriterion("order_state_name not like", value, "orderStateName");
            return (Criteria) this;
        }

        public Criteria andOrderStateNameIn(List<String> values) {
            addCriterion("order_state_name in", values, "orderStateName");
            return (Criteria) this;
        }

        public Criteria andOrderStateNameNotIn(List<String> values) {
            addCriterion("order_state_name not in", values, "orderStateName");
            return (Criteria) this;
        }

        public Criteria andOrderStateNameBetween(String value1, String value2) {
            addCriterion("order_state_name between", value1, value2, "orderStateName");
            return (Criteria) this;
        }

        public Criteria andOrderStateNameNotBetween(String value1, String value2) {
            addCriterion("order_state_name not between", value1, value2, "orderStateName");
            return (Criteria) this;
        }

        public Criteria andBillCreatedAtIsNull() {
            addCriterion("bill_created_at is null");
            return (Criteria) this;
        }

        public Criteria andBillCreatedAtIsNotNull() {
            addCriterion("bill_created_at is not null");
            return (Criteria) this;
        }

        public Criteria andBillCreatedAtEqualTo(Date value) {
            addCriterion("bill_created_at =", value, "billCreatedAt");
            return (Criteria) this;
        }

        public Criteria andBillCreatedAtNotEqualTo(Date value) {
            addCriterion("bill_created_at <>", value, "billCreatedAt");
            return (Criteria) this;
        }

        public Criteria andBillCreatedAtGreaterThan(Date value) {
            addCriterion("bill_created_at >", value, "billCreatedAt");
            return (Criteria) this;
        }

        public Criteria andBillCreatedAtGreaterThanOrEqualTo(Date value) {
            addCriterion("bill_created_at >=", value, "billCreatedAt");
            return (Criteria) this;
        }

        public Criteria andBillCreatedAtLessThan(Date value) {
            addCriterion("bill_created_at <", value, "billCreatedAt");
            return (Criteria) this;
        }

        public Criteria andBillCreatedAtLessThanOrEqualTo(Date value) {
            addCriterion("bill_created_at <=", value, "billCreatedAt");
            return (Criteria) this;
        }

        public Criteria andBillCreatedAtIn(List<Date> values) {
            addCriterion("bill_created_at in", values, "billCreatedAt");
            return (Criteria) this;
        }

        public Criteria andBillCreatedAtNotIn(List<Date> values) {
            addCriterion("bill_created_at not in", values, "billCreatedAt");
            return (Criteria) this;
        }

        public Criteria andBillCreatedAtBetween(Date value1, Date value2) {
            addCriterion("bill_created_at between", value1, value2, "billCreatedAt");
            return (Criteria) this;
        }

        public Criteria andBillCreatedAtNotBetween(Date value1, Date value2) {
            addCriterion("bill_created_at not between", value1, value2, "billCreatedAt");
            return (Criteria) this;
        }

        public Criteria andFinishTimeIsNull() {
            addCriterion("finish_time is null");
            return (Criteria) this;
        }

        public Criteria andFinishTimeIsNotNull() {
            addCriterion("finish_time is not null");
            return (Criteria) this;
        }

        public Criteria andFinishTimeEqualTo(Date value) {
            addCriterion("finish_time =", value, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeNotEqualTo(Date value) {
            addCriterion("finish_time <>", value, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeGreaterThan(Date value) {
            addCriterion("finish_time >", value, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("finish_time >=", value, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeLessThan(Date value) {
            addCriterion("finish_time <", value, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeLessThanOrEqualTo(Date value) {
            addCriterion("finish_time <=", value, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeIn(List<Date> values) {
            addCriterion("finish_time in", values, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeNotIn(List<Date> values) {
            addCriterion("finish_time not in", values, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeBetween(Date value1, Date value2) {
            addCriterion("finish_time between", value1, value2, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeNotBetween(Date value1, Date value2) {
            addCriterion("finish_time not between", value1, value2, "finishTime");
            return (Criteria) this;
        }

        public Criteria andGoodsIdIsNull() {
            addCriterion("goods_id is null");
            return (Criteria) this;
        }

        public Criteria andGoodsIdIsNotNull() {
            addCriterion("goods_id is not null");
            return (Criteria) this;
        }

        public Criteria andGoodsIdEqualTo(Long value) {
            addCriterion("goods_id =", value, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdNotEqualTo(Long value) {
            addCriterion("goods_id <>", value, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdGreaterThan(Long value) {
            addCriterion("goods_id >", value, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdGreaterThanOrEqualTo(Long value) {
            addCriterion("goods_id >=", value, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdLessThan(Long value) {
            addCriterion("goods_id <", value, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdLessThanOrEqualTo(Long value) {
            addCriterion("goods_id <=", value, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdIn(List<Long> values) {
            addCriterion("goods_id in", values, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdNotIn(List<Long> values) {
            addCriterion("goods_id not in", values, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdBetween(Long value1, Long value2) {
            addCriterion("goods_id between", value1, value2, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdNotBetween(Long value1, Long value2) {
            addCriterion("goods_id not between", value1, value2, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsNameIsNull() {
            addCriterion("goods_name is null");
            return (Criteria) this;
        }

        public Criteria andGoodsNameIsNotNull() {
            addCriterion("goods_name is not null");
            return (Criteria) this;
        }

        public Criteria andGoodsNameEqualTo(String value) {
            addCriterion("goods_name =", value, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameNotEqualTo(String value) {
            addCriterion("goods_name <>", value, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameGreaterThan(String value) {
            addCriterion("goods_name >", value, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameGreaterThanOrEqualTo(String value) {
            addCriterion("goods_name >=", value, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameLessThan(String value) {
            addCriterion("goods_name <", value, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameLessThanOrEqualTo(String value) {
            addCriterion("goods_name <=", value, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameLike(String value) {
            addCriterion("goods_name like", value, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameNotLike(String value) {
            addCriterion("goods_name not like", value, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameIn(List<String> values) {
            addCriterion("goods_name in", values, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameNotIn(List<String> values) {
            addCriterion("goods_name not in", values, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameBetween(String value1, String value2) {
            addCriterion("goods_name between", value1, value2, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameNotBetween(String value1, String value2) {
            addCriterion("goods_name not between", value1, value2, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsUnitIsNull() {
            addCriterion("goods_unit is null");
            return (Criteria) this;
        }

        public Criteria andGoodsUnitIsNotNull() {
            addCriterion("goods_unit is not null");
            return (Criteria) this;
        }

        public Criteria andGoodsUnitEqualTo(String value) {
            addCriterion("goods_unit =", value, "goodsUnit");
            return (Criteria) this;
        }

        public Criteria andGoodsUnitNotEqualTo(String value) {
            addCriterion("goods_unit <>", value, "goodsUnit");
            return (Criteria) this;
        }

        public Criteria andGoodsUnitGreaterThan(String value) {
            addCriterion("goods_unit >", value, "goodsUnit");
            return (Criteria) this;
        }

        public Criteria andGoodsUnitGreaterThanOrEqualTo(String value) {
            addCriterion("goods_unit >=", value, "goodsUnit");
            return (Criteria) this;
        }

        public Criteria andGoodsUnitLessThan(String value) {
            addCriterion("goods_unit <", value, "goodsUnit");
            return (Criteria) this;
        }

        public Criteria andGoodsUnitLessThanOrEqualTo(String value) {
            addCriterion("goods_unit <=", value, "goodsUnit");
            return (Criteria) this;
        }

        public Criteria andGoodsUnitLike(String value) {
            addCriterion("goods_unit like", value, "goodsUnit");
            return (Criteria) this;
        }

        public Criteria andGoodsUnitNotLike(String value) {
            addCriterion("goods_unit not like", value, "goodsUnit");
            return (Criteria) this;
        }

        public Criteria andGoodsUnitIn(List<String> values) {
            addCriterion("goods_unit in", values, "goodsUnit");
            return (Criteria) this;
        }

        public Criteria andGoodsUnitNotIn(List<String> values) {
            addCriterion("goods_unit not in", values, "goodsUnit");
            return (Criteria) this;
        }

        public Criteria andGoodsUnitBetween(String value1, String value2) {
            addCriterion("goods_unit between", value1, value2, "goodsUnit");
            return (Criteria) this;
        }

        public Criteria andGoodsUnitNotBetween(String value1, String value2) {
            addCriterion("goods_unit not between", value1, value2, "goodsUnit");
            return (Criteria) this;
        }

        public Criteria andGoodsQuantityIsNull() {
            addCriterion("goods_quantity is null");
            return (Criteria) this;
        }

        public Criteria andGoodsQuantityIsNotNull() {
            addCriterion("goods_quantity is not null");
            return (Criteria) this;
        }

        public Criteria andGoodsQuantityEqualTo(Long value) {
            addCriterion("goods_quantity =", value, "goodsQuantity");
            return (Criteria) this;
        }

        public Criteria andGoodsQuantityNotEqualTo(Long value) {
            addCriterion("goods_quantity <>", value, "goodsQuantity");
            return (Criteria) this;
        }

        public Criteria andGoodsQuantityGreaterThan(Long value) {
            addCriterion("goods_quantity >", value, "goodsQuantity");
            return (Criteria) this;
        }

        public Criteria andGoodsQuantityGreaterThanOrEqualTo(Long value) {
            addCriterion("goods_quantity >=", value, "goodsQuantity");
            return (Criteria) this;
        }

        public Criteria andGoodsQuantityLessThan(Long value) {
            addCriterion("goods_quantity <", value, "goodsQuantity");
            return (Criteria) this;
        }

        public Criteria andGoodsQuantityLessThanOrEqualTo(Long value) {
            addCriterion("goods_quantity <=", value, "goodsQuantity");
            return (Criteria) this;
        }

        public Criteria andGoodsQuantityIn(List<Long> values) {
            addCriterion("goods_quantity in", values, "goodsQuantity");
            return (Criteria) this;
        }

        public Criteria andGoodsQuantityNotIn(List<Long> values) {
            addCriterion("goods_quantity not in", values, "goodsQuantity");
            return (Criteria) this;
        }

        public Criteria andGoodsQuantityBetween(Long value1, Long value2) {
            addCriterion("goods_quantity between", value1, value2, "goodsQuantity");
            return (Criteria) this;
        }

        public Criteria andGoodsQuantityNotBetween(Long value1, Long value2) {
            addCriterion("goods_quantity not between", value1, value2, "goodsQuantity");
            return (Criteria) this;
        }

        public Criteria andGoodsPriceIsNull() {
            addCriterion("goods_price is null");
            return (Criteria) this;
        }

        public Criteria andGoodsPriceIsNotNull() {
            addCriterion("goods_price is not null");
            return (Criteria) this;
        }

        public Criteria andGoodsPriceEqualTo(BigDecimal value) {
            addCriterion("goods_price =", value, "goodsPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsPriceNotEqualTo(BigDecimal value) {
            addCriterion("goods_price <>", value, "goodsPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsPriceGreaterThan(BigDecimal value) {
            addCriterion("goods_price >", value, "goodsPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("goods_price >=", value, "goodsPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsPriceLessThan(BigDecimal value) {
            addCriterion("goods_price <", value, "goodsPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("goods_price <=", value, "goodsPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsPriceIn(List<BigDecimal> values) {
            addCriterion("goods_price in", values, "goodsPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsPriceNotIn(List<BigDecimal> values) {
            addCriterion("goods_price not in", values, "goodsPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("goods_price between", value1, value2, "goodsPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("goods_price not between", value1, value2, "goodsPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsTotalAmountIsNull() {
            addCriterion("goods_total_amount is null");
            return (Criteria) this;
        }

        public Criteria andGoodsTotalAmountIsNotNull() {
            addCriterion("goods_total_amount is not null");
            return (Criteria) this;
        }

        public Criteria andGoodsTotalAmountEqualTo(BigDecimal value) {
            addCriterion("goods_total_amount =", value, "goodsTotalAmount");
            return (Criteria) this;
        }

        public Criteria andGoodsTotalAmountNotEqualTo(BigDecimal value) {
            addCriterion("goods_total_amount <>", value, "goodsTotalAmount");
            return (Criteria) this;
        }

        public Criteria andGoodsTotalAmountGreaterThan(BigDecimal value) {
            addCriterion("goods_total_amount >", value, "goodsTotalAmount");
            return (Criteria) this;
        }

        public Criteria andGoodsTotalAmountGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("goods_total_amount >=", value, "goodsTotalAmount");
            return (Criteria) this;
        }

        public Criteria andGoodsTotalAmountLessThan(BigDecimal value) {
            addCriterion("goods_total_amount <", value, "goodsTotalAmount");
            return (Criteria) this;
        }

        public Criteria andGoodsTotalAmountLessThanOrEqualTo(BigDecimal value) {
            addCriterion("goods_total_amount <=", value, "goodsTotalAmount");
            return (Criteria) this;
        }

        public Criteria andGoodsTotalAmountIn(List<BigDecimal> values) {
            addCriterion("goods_total_amount in", values, "goodsTotalAmount");
            return (Criteria) this;
        }

        public Criteria andGoodsTotalAmountNotIn(List<BigDecimal> values) {
            addCriterion("goods_total_amount not in", values, "goodsTotalAmount");
            return (Criteria) this;
        }

        public Criteria andGoodsTotalAmountBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("goods_total_amount between", value1, value2, "goodsTotalAmount");
            return (Criteria) this;
        }

        public Criteria andGoodsTotalAmountNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("goods_total_amount not between", value1, value2, "goodsTotalAmount");
            return (Criteria) this;
        }

        public Criteria andMerchTaxRateIsNull() {
            addCriterion("merch_tax_rate is null");
            return (Criteria) this;
        }

        public Criteria andMerchTaxRateIsNotNull() {
            addCriterion("merch_tax_rate is not null");
            return (Criteria) this;
        }

        public Criteria andMerchTaxRateEqualTo(BigDecimal value) {
            addCriterion("merch_tax_rate =", value, "merchTaxRate");
            return (Criteria) this;
        }

        public Criteria andMerchTaxRateNotEqualTo(BigDecimal value) {
            addCriterion("merch_tax_rate <>", value, "merchTaxRate");
            return (Criteria) this;
        }

        public Criteria andMerchTaxRateGreaterThan(BigDecimal value) {
            addCriterion("merch_tax_rate >", value, "merchTaxRate");
            return (Criteria) this;
        }

        public Criteria andMerchTaxRateGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("merch_tax_rate >=", value, "merchTaxRate");
            return (Criteria) this;
        }

        public Criteria andMerchTaxRateLessThan(BigDecimal value) {
            addCriterion("merch_tax_rate <", value, "merchTaxRate");
            return (Criteria) this;
        }

        public Criteria andMerchTaxRateLessThanOrEqualTo(BigDecimal value) {
            addCriterion("merch_tax_rate <=", value, "merchTaxRate");
            return (Criteria) this;
        }

        public Criteria andMerchTaxRateIn(List<BigDecimal> values) {
            addCriterion("merch_tax_rate in", values, "merchTaxRate");
            return (Criteria) this;
        }

        public Criteria andMerchTaxRateNotIn(List<BigDecimal> values) {
            addCriterion("merch_tax_rate not in", values, "merchTaxRate");
            return (Criteria) this;
        }

        public Criteria andMerchTaxRateBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("merch_tax_rate between", value1, value2, "merchTaxRate");
            return (Criteria) this;
        }

        public Criteria andMerchTaxRateNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("merch_tax_rate not between", value1, value2, "merchTaxRate");
            return (Criteria) this;
        }

        public Criteria andMerchTaxCodeIsNull() {
            addCriterion("merch_tax_code is null");
            return (Criteria) this;
        }

        public Criteria andMerchTaxCodeIsNotNull() {
            addCriterion("merch_tax_code is not null");
            return (Criteria) this;
        }

        public Criteria andMerchTaxCodeEqualTo(String value) {
            addCriterion("merch_tax_code =", value, "merchTaxCode");
            return (Criteria) this;
        }

        public Criteria andMerchTaxCodeNotEqualTo(String value) {
            addCriterion("merch_tax_code <>", value, "merchTaxCode");
            return (Criteria) this;
        }

        public Criteria andMerchTaxCodeGreaterThan(String value) {
            addCriterion("merch_tax_code >", value, "merchTaxCode");
            return (Criteria) this;
        }

        public Criteria andMerchTaxCodeGreaterThanOrEqualTo(String value) {
            addCriterion("merch_tax_code >=", value, "merchTaxCode");
            return (Criteria) this;
        }

        public Criteria andMerchTaxCodeLessThan(String value) {
            addCriterion("merch_tax_code <", value, "merchTaxCode");
            return (Criteria) this;
        }

        public Criteria andMerchTaxCodeLessThanOrEqualTo(String value) {
            addCriterion("merch_tax_code <=", value, "merchTaxCode");
            return (Criteria) this;
        }

        public Criteria andMerchTaxCodeLike(String value) {
            addCriterion("merch_tax_code like", value, "merchTaxCode");
            return (Criteria) this;
        }

        public Criteria andMerchTaxCodeNotLike(String value) {
            addCriterion("merch_tax_code not like", value, "merchTaxCode");
            return (Criteria) this;
        }

        public Criteria andMerchTaxCodeIn(List<String> values) {
            addCriterion("merch_tax_code in", values, "merchTaxCode");
            return (Criteria) this;
        }

        public Criteria andMerchTaxCodeNotIn(List<String> values) {
            addCriterion("merch_tax_code not in", values, "merchTaxCode");
            return (Criteria) this;
        }

        public Criteria andMerchTaxCodeBetween(String value1, String value2) {
            addCriterion("merch_tax_code between", value1, value2, "merchTaxCode");
            return (Criteria) this;
        }

        public Criteria andMerchTaxCodeNotBetween(String value1, String value2) {
            addCriterion("merch_tax_code not between", value1, value2, "merchTaxCode");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderSnIsNull() {
            addCriterion("accounting_order_sn is null");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderSnIsNotNull() {
            addCriterion("accounting_order_sn is not null");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderSnEqualTo(String value) {
            addCriterion("accounting_order_sn =", value, "accountingOrderSn");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderSnNotEqualTo(String value) {
            addCriterion("accounting_order_sn <>", value, "accountingOrderSn");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderSnGreaterThan(String value) {
            addCriterion("accounting_order_sn >", value, "accountingOrderSn");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderSnGreaterThanOrEqualTo(String value) {
            addCriterion("accounting_order_sn >=", value, "accountingOrderSn");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderSnLessThan(String value) {
            addCriterion("accounting_order_sn <", value, "accountingOrderSn");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderSnLessThanOrEqualTo(String value) {
            addCriterion("accounting_order_sn <=", value, "accountingOrderSn");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderSnLike(String value) {
            addCriterion("accounting_order_sn like", value, "accountingOrderSn");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderSnNotLike(String value) {
            addCriterion("accounting_order_sn not like", value, "accountingOrderSn");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderSnIn(List<String> values) {
            addCriterion("accounting_order_sn in", values, "accountingOrderSn");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderSnNotIn(List<String> values) {
            addCriterion("accounting_order_sn not in", values, "accountingOrderSn");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderSnBetween(String value1, String value2) {
            addCriterion("accounting_order_sn between", value1, value2, "accountingOrderSn");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderSnNotBetween(String value1, String value2) {
            addCriterion("accounting_order_sn not between", value1, value2, "accountingOrderSn");
            return (Criteria) this;
        }

        public Criteria andAccountingStateIsNull() {
            addCriterion("accounting_state is null");
            return (Criteria) this;
        }

        public Criteria andAccountingStateIsNotNull() {
            addCriterion("accounting_state is not null");
            return (Criteria) this;
        }

        public Criteria andAccountingStateEqualTo(Byte value) {
            addCriterion("accounting_state =", value, "accountingState");
            return (Criteria) this;
        }

        public Criteria andAccountingStateNotEqualTo(Byte value) {
            addCriterion("accounting_state <>", value, "accountingState");
            return (Criteria) this;
        }

        public Criteria andAccountingStateGreaterThan(Byte value) {
            addCriterion("accounting_state >", value, "accountingState");
            return (Criteria) this;
        }

        public Criteria andAccountingStateGreaterThanOrEqualTo(Byte value) {
            addCriterion("accounting_state >=", value, "accountingState");
            return (Criteria) this;
        }

        public Criteria andAccountingStateLessThan(Byte value) {
            addCriterion("accounting_state <", value, "accountingState");
            return (Criteria) this;
        }

        public Criteria andAccountingStateLessThanOrEqualTo(Byte value) {
            addCriterion("accounting_state <=", value, "accountingState");
            return (Criteria) this;
        }

        public Criteria andAccountingStateIn(List<Byte> values) {
            addCriterion("accounting_state in", values, "accountingState");
            return (Criteria) this;
        }

        public Criteria andAccountingStateNotIn(List<Byte> values) {
            addCriterion("accounting_state not in", values, "accountingState");
            return (Criteria) this;
        }

        public Criteria andAccountingStateBetween(Byte value1, Byte value2) {
            addCriterion("accounting_state between", value1, value2, "accountingState");
            return (Criteria) this;
        }

        public Criteria andAccountingStateNotBetween(Byte value1, Byte value2) {
            addCriterion("accounting_state not between", value1, value2, "accountingState");
            return (Criteria) this;
        }

        public Criteria andMakeInvoiceStatusIsNull() {
            addCriterion("make_invoice_status is null");
            return (Criteria) this;
        }

        public Criteria andMakeInvoiceStatusIsNotNull() {
            addCriterion("make_invoice_status is not null");
            return (Criteria) this;
        }

        public Criteria andMakeInvoiceStatusEqualTo(Byte value) {
            addCriterion("make_invoice_status =", value, "makeInvoiceStatus");
            return (Criteria) this;
        }

        public Criteria andMakeInvoiceStatusNotEqualTo(Byte value) {
            addCriterion("make_invoice_status <>", value, "makeInvoiceStatus");
            return (Criteria) this;
        }

        public Criteria andMakeInvoiceStatusGreaterThan(Byte value) {
            addCriterion("make_invoice_status >", value, "makeInvoiceStatus");
            return (Criteria) this;
        }

        public Criteria andMakeInvoiceStatusGreaterThanOrEqualTo(Byte value) {
            addCriterion("make_invoice_status >=", value, "makeInvoiceStatus");
            return (Criteria) this;
        }

        public Criteria andMakeInvoiceStatusLessThan(Byte value) {
            addCriterion("make_invoice_status <", value, "makeInvoiceStatus");
            return (Criteria) this;
        }

        public Criteria andMakeInvoiceStatusLessThanOrEqualTo(Byte value) {
            addCriterion("make_invoice_status <=", value, "makeInvoiceStatus");
            return (Criteria) this;
        }

        public Criteria andMakeInvoiceStatusIn(List<Byte> values) {
            addCriterion("make_invoice_status in", values, "makeInvoiceStatus");
            return (Criteria) this;
        }

        public Criteria andMakeInvoiceStatusNotIn(List<Byte> values) {
            addCriterion("make_invoice_status not in", values, "makeInvoiceStatus");
            return (Criteria) this;
        }

        public Criteria andMakeInvoiceStatusBetween(Byte value1, Byte value2) {
            addCriterion("make_invoice_status between", value1, value2, "makeInvoiceStatus");
            return (Criteria) this;
        }

        public Criteria andMakeInvoiceStatusNotBetween(Byte value1, Byte value2) {
            addCriterion("make_invoice_status not between", value1, value2, "makeInvoiceStatus");
            return (Criteria) this;
        }

        public Criteria andBackStatusIsNull() {
            addCriterion("back_status is null");
            return (Criteria) this;
        }

        public Criteria andBackStatusIsNotNull() {
            addCriterion("back_status is not null");
            return (Criteria) this;
        }

        public Criteria andBackStatusEqualTo(Byte value) {
            addCriterion("back_status =", value, "backStatus");
            return (Criteria) this;
        }

        public Criteria andBackStatusNotEqualTo(Byte value) {
            addCriterion("back_status <>", value, "backStatus");
            return (Criteria) this;
        }

        public Criteria andBackStatusGreaterThan(Byte value) {
            addCriterion("back_status >", value, "backStatus");
            return (Criteria) this;
        }

        public Criteria andBackStatusGreaterThanOrEqualTo(Byte value) {
            addCriterion("back_status >=", value, "backStatus");
            return (Criteria) this;
        }

        public Criteria andBackStatusLessThan(Byte value) {
            addCriterion("back_status <", value, "backStatus");
            return (Criteria) this;
        }

        public Criteria andBackStatusLessThanOrEqualTo(Byte value) {
            addCriterion("back_status <=", value, "backStatus");
            return (Criteria) this;
        }

        public Criteria andBackStatusIn(List<Byte> values) {
            addCriterion("back_status in", values, "backStatus");
            return (Criteria) this;
        }

        public Criteria andBackStatusNotIn(List<Byte> values) {
            addCriterion("back_status not in", values, "backStatus");
            return (Criteria) this;
        }

        public Criteria andBackStatusBetween(Byte value1, Byte value2) {
            addCriterion("back_status between", value1, value2, "backStatus");
            return (Criteria) this;
        }

        public Criteria andBackStatusNotBetween(Byte value1, Byte value2) {
            addCriterion("back_status not between", value1, value2, "backStatus");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNull() {
            addCriterion("remark is null");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNotNull() {
            addCriterion("remark is not null");
            return (Criteria) this;
        }

        public Criteria andRemarkEqualTo(String value) {
            addCriterion("remark =", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotEqualTo(String value) {
            addCriterion("remark <>", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThan(String value) {
            addCriterion("remark >", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThanOrEqualTo(String value) {
            addCriterion("remark >=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThan(String value) {
            addCriterion("remark <", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThanOrEqualTo(String value) {
            addCriterion("remark <=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLike(String value) {
            addCriterion("remark like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotLike(String value) {
            addCriterion("remark not like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkIn(List<String> values) {
            addCriterion("remark in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotIn(List<String> values) {
            addCriterion("remark not in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkBetween(String value1, String value2) {
            addCriterion("remark between", value1, value2, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotBetween(String value1, String value2) {
            addCriterion("remark not between", value1, value2, "remark");
            return (Criteria) this;
        }

        public Criteria andCostNoTaxIsNull() {
            addCriterion("cost_no_tax is null");
            return (Criteria) this;
        }

        public Criteria andCostNoTaxIsNotNull() {
            addCriterion("cost_no_tax is not null");
            return (Criteria) this;
        }

        public Criteria andCostNoTaxEqualTo(BigDecimal value) {
            addCriterion("cost_no_tax =", value, "costNoTax");
            return (Criteria) this;
        }

        public Criteria andCostNoTaxNotEqualTo(BigDecimal value) {
            addCriterion("cost_no_tax <>", value, "costNoTax");
            return (Criteria) this;
        }

        public Criteria andCostNoTaxGreaterThan(BigDecimal value) {
            addCriterion("cost_no_tax >", value, "costNoTax");
            return (Criteria) this;
        }

        public Criteria andCostNoTaxGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("cost_no_tax >=", value, "costNoTax");
            return (Criteria) this;
        }

        public Criteria andCostNoTaxLessThan(BigDecimal value) {
            addCriterion("cost_no_tax <", value, "costNoTax");
            return (Criteria) this;
        }

        public Criteria andCostNoTaxLessThanOrEqualTo(BigDecimal value) {
            addCriterion("cost_no_tax <=", value, "costNoTax");
            return (Criteria) this;
        }

        public Criteria andCostNoTaxIn(List<BigDecimal> values) {
            addCriterion("cost_no_tax in", values, "costNoTax");
            return (Criteria) this;
        }

        public Criteria andCostNoTaxNotIn(List<BigDecimal> values) {
            addCriterion("cost_no_tax not in", values, "costNoTax");
            return (Criteria) this;
        }

        public Criteria andCostNoTaxBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("cost_no_tax between", value1, value2, "costNoTax");
            return (Criteria) this;
        }

        public Criteria andCostNoTaxNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("cost_no_tax not between", value1, value2, "costNoTax");
            return (Criteria) this;
        }

        public Criteria andTaxAmountIsNull() {
            addCriterion("tax_amount is null");
            return (Criteria) this;
        }

        public Criteria andTaxAmountIsNotNull() {
            addCriterion("tax_amount is not null");
            return (Criteria) this;
        }

        public Criteria andTaxAmountEqualTo(BigDecimal value) {
            addCriterion("tax_amount =", value, "taxAmount");
            return (Criteria) this;
        }

        public Criteria andTaxAmountNotEqualTo(BigDecimal value) {
            addCriterion("tax_amount <>", value, "taxAmount");
            return (Criteria) this;
        }

        public Criteria andTaxAmountGreaterThan(BigDecimal value) {
            addCriterion("tax_amount >", value, "taxAmount");
            return (Criteria) this;
        }

        public Criteria andTaxAmountGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("tax_amount >=", value, "taxAmount");
            return (Criteria) this;
        }

        public Criteria andTaxAmountLessThan(BigDecimal value) {
            addCriterion("tax_amount <", value, "taxAmount");
            return (Criteria) this;
        }

        public Criteria andTaxAmountLessThanOrEqualTo(BigDecimal value) {
            addCriterion("tax_amount <=", value, "taxAmount");
            return (Criteria) this;
        }

        public Criteria andTaxAmountIn(List<BigDecimal> values) {
            addCriterion("tax_amount in", values, "taxAmount");
            return (Criteria) this;
        }

        public Criteria andTaxAmountNotIn(List<BigDecimal> values) {
            addCriterion("tax_amount not in", values, "taxAmount");
            return (Criteria) this;
        }

        public Criteria andTaxAmountBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("tax_amount between", value1, value2, "taxAmount");
            return (Criteria) this;
        }

        public Criteria andTaxAmountNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("tax_amount not between", value1, value2, "taxAmount");
            return (Criteria) this;
        }

        public Criteria andPayableAmountIsNull() {
            addCriterion("payable_amount is null");
            return (Criteria) this;
        }

        public Criteria andPayableAmountIsNotNull() {
            addCriterion("payable_amount is not null");
            return (Criteria) this;
        }

        public Criteria andPayableAmountEqualTo(BigDecimal value) {
            addCriterion("payable_amount =", value, "payableAmount");
            return (Criteria) this;
        }

        public Criteria andPayableAmountNotEqualTo(BigDecimal value) {
            addCriterion("payable_amount <>", value, "payableAmount");
            return (Criteria) this;
        }

        public Criteria andPayableAmountGreaterThan(BigDecimal value) {
            addCriterion("payable_amount >", value, "payableAmount");
            return (Criteria) this;
        }

        public Criteria andPayableAmountGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("payable_amount >=", value, "payableAmount");
            return (Criteria) this;
        }

        public Criteria andPayableAmountLessThan(BigDecimal value) {
            addCriterion("payable_amount <", value, "payableAmount");
            return (Criteria) this;
        }

        public Criteria andPayableAmountLessThanOrEqualTo(BigDecimal value) {
            addCriterion("payable_amount <=", value, "payableAmount");
            return (Criteria) this;
        }

        public Criteria andPayableAmountIn(List<BigDecimal> values) {
            addCriterion("payable_amount in", values, "payableAmount");
            return (Criteria) this;
        }

        public Criteria andPayableAmountNotIn(List<BigDecimal> values) {
            addCriterion("payable_amount not in", values, "payableAmount");
            return (Criteria) this;
        }

        public Criteria andPayableAmountBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("payable_amount between", value1, value2, "payableAmount");
            return (Criteria) this;
        }

        public Criteria andPayableAmountNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("payable_amount not between", value1, value2, "payableAmount");
            return (Criteria) this;
        }

        public Criteria andAccountAtIsNull() {
            addCriterion("account_at is null");
            return (Criteria) this;
        }

        public Criteria andAccountAtIsNotNull() {
            addCriterion("account_at is not null");
            return (Criteria) this;
        }

        public Criteria andAccountAtEqualTo(Date value) {
            addCriterion("account_at =", value, "accountAt");
            return (Criteria) this;
        }

        public Criteria andAccountAtNotEqualTo(Date value) {
            addCriterion("account_at <>", value, "accountAt");
            return (Criteria) this;
        }

        public Criteria andAccountAtGreaterThan(Date value) {
            addCriterion("account_at >", value, "accountAt");
            return (Criteria) this;
        }

        public Criteria andAccountAtGreaterThanOrEqualTo(Date value) {
            addCriterion("account_at >=", value, "accountAt");
            return (Criteria) this;
        }

        public Criteria andAccountAtLessThan(Date value) {
            addCriterion("account_at <", value, "accountAt");
            return (Criteria) this;
        }

        public Criteria andAccountAtLessThanOrEqualTo(Date value) {
            addCriterion("account_at <=", value, "accountAt");
            return (Criteria) this;
        }

        public Criteria andAccountAtIn(List<Date> values) {
            addCriterion("account_at in", values, "accountAt");
            return (Criteria) this;
        }

        public Criteria andAccountAtNotIn(List<Date> values) {
            addCriterion("account_at not in", values, "accountAt");
            return (Criteria) this;
        }

        public Criteria andAccountAtBetween(Date value1, Date value2) {
            addCriterion("account_at between", value1, value2, "accountAt");
            return (Criteria) this;
        }

        public Criteria andAccountAtNotBetween(Date value1, Date value2) {
            addCriterion("account_at not between", value1, value2, "accountAt");
            return (Criteria) this;
        }

        public Criteria andAccountStateIsNull() {
            addCriterion("account_state is null");
            return (Criteria) this;
        }

        public Criteria andAccountStateIsNotNull() {
            addCriterion("account_state is not null");
            return (Criteria) this;
        }

        public Criteria andAccountStateEqualTo(Byte value) {
            addCriterion("account_state =", value, "accountState");
            return (Criteria) this;
        }

        public Criteria andAccountStateNotEqualTo(Byte value) {
            addCriterion("account_state <>", value, "accountState");
            return (Criteria) this;
        }

        public Criteria andAccountStateGreaterThan(Byte value) {
            addCriterion("account_state >", value, "accountState");
            return (Criteria) this;
        }

        public Criteria andAccountStateGreaterThanOrEqualTo(Byte value) {
            addCriterion("account_state >=", value, "accountState");
            return (Criteria) this;
        }

        public Criteria andAccountStateLessThan(Byte value) {
            addCriterion("account_state <", value, "accountState");
            return (Criteria) this;
        }

        public Criteria andAccountStateLessThanOrEqualTo(Byte value) {
            addCriterion("account_state <=", value, "accountState");
            return (Criteria) this;
        }

        public Criteria andAccountStateIn(List<Byte> values) {
            addCriterion("account_state in", values, "accountState");
            return (Criteria) this;
        }

        public Criteria andAccountStateNotIn(List<Byte> values) {
            addCriterion("account_state not in", values, "accountState");
            return (Criteria) this;
        }

        public Criteria andAccountStateBetween(Byte value1, Byte value2) {
            addCriterion("account_state between", value1, value2, "accountState");
            return (Criteria) this;
        }

        public Criteria andAccountStateNotBetween(Byte value1, Byte value2) {
            addCriterion("account_state not between", value1, value2, "accountState");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdIsNull() {
            addCriterion("update_user_id is null");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdIsNotNull() {
            addCriterion("update_user_id is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdEqualTo(Long value) {
            addCriterion("update_user_id =", value, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdNotEqualTo(Long value) {
            addCriterion("update_user_id <>", value, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdGreaterThan(Long value) {
            addCriterion("update_user_id >", value, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdGreaterThanOrEqualTo(Long value) {
            addCriterion("update_user_id >=", value, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdLessThan(Long value) {
            addCriterion("update_user_id <", value, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdLessThanOrEqualTo(Long value) {
            addCriterion("update_user_id <=", value, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdIn(List<Long> values) {
            addCriterion("update_user_id in", values, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdNotIn(List<Long> values) {
            addCriterion("update_user_id not in", values, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdBetween(Long value1, Long value2) {
            addCriterion("update_user_id between", value1, value2, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdNotBetween(Long value1, Long value2) {
            addCriterion("update_user_id not between", value1, value2, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNameIsNull() {
            addCriterion("update_user_name is null");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNameIsNotNull() {
            addCriterion("update_user_name is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNameEqualTo(String value) {
            addCriterion("update_user_name =", value, "updateUserName");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNameNotEqualTo(String value) {
            addCriterion("update_user_name <>", value, "updateUserName");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNameGreaterThan(String value) {
            addCriterion("update_user_name >", value, "updateUserName");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNameGreaterThanOrEqualTo(String value) {
            addCriterion("update_user_name >=", value, "updateUserName");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNameLessThan(String value) {
            addCriterion("update_user_name <", value, "updateUserName");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNameLessThanOrEqualTo(String value) {
            addCriterion("update_user_name <=", value, "updateUserName");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNameLike(String value) {
            addCriterion("update_user_name like", value, "updateUserName");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNameNotLike(String value) {
            addCriterion("update_user_name not like", value, "updateUserName");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNameIn(List<String> values) {
            addCriterion("update_user_name in", values, "updateUserName");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNameNotIn(List<String> values) {
            addCriterion("update_user_name not in", values, "updateUserName");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNameBetween(String value1, String value2) {
            addCriterion("update_user_name between", value1, value2, "updateUserName");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNameNotBetween(String value1, String value2) {
            addCriterion("update_user_name not between", value1, value2, "updateUserName");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("update_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("update_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("update_time =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("update_time <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("update_time >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("update_time >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("update_time <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("update_time <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("update_time in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("update_time not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("update_time between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("update_time not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIsNull() {
            addCriterion("created_at is null");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIsNotNull() {
            addCriterion("created_at is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedAtEqualTo(Date value) {
            addCriterion("created_at =", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotEqualTo(Date value) {
            addCriterion("created_at <>", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtGreaterThan(Date value) {
            addCriterion("created_at >", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtGreaterThanOrEqualTo(Date value) {
            addCriterion("created_at >=", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtLessThan(Date value) {
            addCriterion("created_at <", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtLessThanOrEqualTo(Date value) {
            addCriterion("created_at <=", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIn(List<Date> values) {
            addCriterion("created_at in", values, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotIn(List<Date> values) {
            addCriterion("created_at not in", values, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtBetween(Date value1, Date value2) {
            addCriterion("created_at between", value1, value2, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotBetween(Date value1, Date value2) {
            addCriterion("created_at not between", value1, value2, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdIsNull() {
            addCriterion("create_user_id is null");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdIsNotNull() {
            addCriterion("create_user_id is not null");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdEqualTo(Long value) {
            addCriterion("create_user_id =", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdNotEqualTo(Long value) {
            addCriterion("create_user_id <>", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdGreaterThan(Long value) {
            addCriterion("create_user_id >", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdGreaterThanOrEqualTo(Long value) {
            addCriterion("create_user_id >=", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdLessThan(Long value) {
            addCriterion("create_user_id <", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdLessThanOrEqualTo(Long value) {
            addCriterion("create_user_id <=", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdIn(List<Long> values) {
            addCriterion("create_user_id in", values, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdNotIn(List<Long> values) {
            addCriterion("create_user_id not in", values, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdBetween(Long value1, Long value2) {
            addCriterion("create_user_id between", value1, value2, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdNotBetween(Long value1, Long value2) {
            addCriterion("create_user_id not between", value1, value2, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserNameIsNull() {
            addCriterion("create_user_name is null");
            return (Criteria) this;
        }

        public Criteria andCreateUserNameIsNotNull() {
            addCriterion("create_user_name is not null");
            return (Criteria) this;
        }

        public Criteria andCreateUserNameEqualTo(String value) {
            addCriterion("create_user_name =", value, "createUserName");
            return (Criteria) this;
        }

        public Criteria andCreateUserNameNotEqualTo(String value) {
            addCriterion("create_user_name <>", value, "createUserName");
            return (Criteria) this;
        }

        public Criteria andCreateUserNameGreaterThan(String value) {
            addCriterion("create_user_name >", value, "createUserName");
            return (Criteria) this;
        }

        public Criteria andCreateUserNameGreaterThanOrEqualTo(String value) {
            addCriterion("create_user_name >=", value, "createUserName");
            return (Criteria) this;
        }

        public Criteria andCreateUserNameLessThan(String value) {
            addCriterion("create_user_name <", value, "createUserName");
            return (Criteria) this;
        }

        public Criteria andCreateUserNameLessThanOrEqualTo(String value) {
            addCriterion("create_user_name <=", value, "createUserName");
            return (Criteria) this;
        }

        public Criteria andCreateUserNameLike(String value) {
            addCriterion("create_user_name like", value, "createUserName");
            return (Criteria) this;
        }

        public Criteria andCreateUserNameNotLike(String value) {
            addCriterion("create_user_name not like", value, "createUserName");
            return (Criteria) this;
        }

        public Criteria andCreateUserNameIn(List<String> values) {
            addCriterion("create_user_name in", values, "createUserName");
            return (Criteria) this;
        }

        public Criteria andCreateUserNameNotIn(List<String> values) {
            addCriterion("create_user_name not in", values, "createUserName");
            return (Criteria) this;
        }

        public Criteria andCreateUserNameBetween(String value1, String value2) {
            addCriterion("create_user_name between", value1, value2, "createUserName");
            return (Criteria) this;
        }

        public Criteria andCreateUserNameNotBetween(String value1, String value2) {
            addCriterion("create_user_name not between", value1, value2, "createUserName");
            return (Criteria) this;
        }

        public Criteria andDataTypeIsNull() {
            addCriterion("data_type is null");
            return (Criteria) this;
        }

        public Criteria andDataTypeIsNotNull() {
            addCriterion("data_type is not null");
            return (Criteria) this;
        }

        public Criteria andDataTypeEqualTo(Byte value) {
            addCriterion("data_type =", value, "dataType");
            return (Criteria) this;
        }

        public Criteria andDataTypeNotEqualTo(Byte value) {
            addCriterion("data_type <>", value, "dataType");
            return (Criteria) this;
        }

        public Criteria andDataTypeGreaterThan(Byte value) {
            addCriterion("data_type >", value, "dataType");
            return (Criteria) this;
        }

        public Criteria andDataTypeGreaterThanOrEqualTo(Byte value) {
            addCriterion("data_type >=", value, "dataType");
            return (Criteria) this;
        }

        public Criteria andDataTypeLessThan(Byte value) {
            addCriterion("data_type <", value, "dataType");
            return (Criteria) this;
        }

        public Criteria andDataTypeLessThanOrEqualTo(Byte value) {
            addCriterion("data_type <=", value, "dataType");
            return (Criteria) this;
        }

        public Criteria andDataTypeIn(List<Byte> values) {
            addCriterion("data_type in", values, "dataType");
            return (Criteria) this;
        }

        public Criteria andDataTypeNotIn(List<Byte> values) {
            addCriterion("data_type not in", values, "dataType");
            return (Criteria) this;
        }

        public Criteria andDataTypeBetween(Byte value1, Byte value2) {
            addCriterion("data_type between", value1, value2, "dataType");
            return (Criteria) this;
        }

        public Criteria andDataTypeNotBetween(Byte value1, Byte value2) {
            addCriterion("data_type not between", value1, value2, "dataType");
            return (Criteria) this;
        }

        public Criteria andBalanceCostIsNull() {
            addCriterion("balance_cost is null");
            return (Criteria) this;
        }

        public Criteria andBalanceCostIsNotNull() {
            addCriterion("balance_cost is not null");
            return (Criteria) this;
        }

        public Criteria andBalanceCostEqualTo(BigDecimal value) {
            addCriterion("balance_cost =", value, "balanceCost");
            return (Criteria) this;
        }

        public Criteria andBalanceCostNotEqualTo(BigDecimal value) {
            addCriterion("balance_cost <>", value, "balanceCost");
            return (Criteria) this;
        }

        public Criteria andBalanceCostGreaterThan(BigDecimal value) {
            addCriterion("balance_cost >", value, "balanceCost");
            return (Criteria) this;
        }

        public Criteria andBalanceCostGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("balance_cost >=", value, "balanceCost");
            return (Criteria) this;
        }

        public Criteria andBalanceCostLessThan(BigDecimal value) {
            addCriterion("balance_cost <", value, "balanceCost");
            return (Criteria) this;
        }

        public Criteria andBalanceCostLessThanOrEqualTo(BigDecimal value) {
            addCriterion("balance_cost <=", value, "balanceCost");
            return (Criteria) this;
        }

        public Criteria andBalanceCostIn(List<BigDecimal> values) {
            addCriterion("balance_cost in", values, "balanceCost");
            return (Criteria) this;
        }

        public Criteria andBalanceCostNotIn(List<BigDecimal> values) {
            addCriterion("balance_cost not in", values, "balanceCost");
            return (Criteria) this;
        }

        public Criteria andBalanceCostBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("balance_cost between", value1, value2, "balanceCost");
            return (Criteria) this;
        }

        public Criteria andBalanceCostNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("balance_cost not between", value1, value2, "balanceCost");
            return (Criteria) this;
        }

        public Criteria andChargeGoodsIdIsNull() {
            addCriterion("charge_goods_id is null");
            return (Criteria) this;
        }

        public Criteria andChargeGoodsIdIsNotNull() {
            addCriterion("charge_goods_id is not null");
            return (Criteria) this;
        }

        public Criteria andChargeGoodsIdEqualTo(Long value) {
            addCriterion("charge_goods_id =", value, "chargeGoodsId");
            return (Criteria) this;
        }

        public Criteria andChargeGoodsIdNotEqualTo(Long value) {
            addCriterion("charge_goods_id <>", value, "chargeGoodsId");
            return (Criteria) this;
        }

        public Criteria andChargeGoodsIdGreaterThan(Long value) {
            addCriterion("charge_goods_id >", value, "chargeGoodsId");
            return (Criteria) this;
        }

        public Criteria andChargeGoodsIdGreaterThanOrEqualTo(Long value) {
            addCriterion("charge_goods_id >=", value, "chargeGoodsId");
            return (Criteria) this;
        }

        public Criteria andChargeGoodsIdLessThan(Long value) {
            addCriterion("charge_goods_id <", value, "chargeGoodsId");
            return (Criteria) this;
        }

        public Criteria andChargeGoodsIdLessThanOrEqualTo(Long value) {
            addCriterion("charge_goods_id <=", value, "chargeGoodsId");
            return (Criteria) this;
        }

        public Criteria andChargeGoodsIdIn(List<Long> values) {
            addCriterion("charge_goods_id in", values, "chargeGoodsId");
            return (Criteria) this;
        }

        public Criteria andChargeGoodsIdNotIn(List<Long> values) {
            addCriterion("charge_goods_id not in", values, "chargeGoodsId");
            return (Criteria) this;
        }

        public Criteria andChargeGoodsIdBetween(Long value1, Long value2) {
            addCriterion("charge_goods_id between", value1, value2, "chargeGoodsId");
            return (Criteria) this;
        }

        public Criteria andChargeGoodsIdNotBetween(Long value1, Long value2) {
            addCriterion("charge_goods_id not between", value1, value2, "chargeGoodsId");
            return (Criteria) this;
        }

        public Criteria andPayableDayIdIsNull() {
            addCriterion("payable_day_id is null");
            return (Criteria) this;
        }

        public Criteria andPayableDayIdIsNotNull() {
            addCriterion("payable_day_id is not null");
            return (Criteria) this;
        }

        public Criteria andPayableDayIdEqualTo(Long value) {
            addCriterion("payable_day_id =", value, "payableDayId");
            return (Criteria) this;
        }

        public Criteria andPayableDayIdNotEqualTo(Long value) {
            addCriterion("payable_day_id <>", value, "payableDayId");
            return (Criteria) this;
        }

        public Criteria andPayableDayIdGreaterThan(Long value) {
            addCriterion("payable_day_id >", value, "payableDayId");
            return (Criteria) this;
        }

        public Criteria andPayableDayIdGreaterThanOrEqualTo(Long value) {
            addCriterion("payable_day_id >=", value, "payableDayId");
            return (Criteria) this;
        }

        public Criteria andPayableDayIdLessThan(Long value) {
            addCriterion("payable_day_id <", value, "payableDayId");
            return (Criteria) this;
        }

        public Criteria andPayableDayIdLessThanOrEqualTo(Long value) {
            addCriterion("payable_day_id <=", value, "payableDayId");
            return (Criteria) this;
        }

        public Criteria andPayableDayIdIn(List<Long> values) {
            addCriterion("payable_day_id in", values, "payableDayId");
            return (Criteria) this;
        }

        public Criteria andPayableDayIdNotIn(List<Long> values) {
            addCriterion("payable_day_id not in", values, "payableDayId");
            return (Criteria) this;
        }

        public Criteria andPayableDayIdBetween(Long value1, Long value2) {
            addCriterion("payable_day_id between", value1, value2, "payableDayId");
            return (Criteria) this;
        }

        public Criteria andPayableDayIdNotBetween(Long value1, Long value2) {
            addCriterion("payable_day_id not between", value1, value2, "payableDayId");
            return (Criteria) this;
        }

        public Criteria andChargePayableDayIdIsNull() {
            addCriterion("charge_payable_day_id is null");
            return (Criteria) this;
        }

        public Criteria andChargePayableDayIdIsNotNull() {
            addCriterion("charge_payable_day_id is not null");
            return (Criteria) this;
        }

        public Criteria andChargePayableDayIdEqualTo(Long value) {
            addCriterion("charge_payable_day_id =", value, "chargePayableDayId");
            return (Criteria) this;
        }

        public Criteria andChargePayableDayIdNotEqualTo(Long value) {
            addCriterion("charge_payable_day_id <>", value, "chargePayableDayId");
            return (Criteria) this;
        }

        public Criteria andChargePayableDayIdGreaterThan(Long value) {
            addCriterion("charge_payable_day_id >", value, "chargePayableDayId");
            return (Criteria) this;
        }

        public Criteria andChargePayableDayIdGreaterThanOrEqualTo(Long value) {
            addCriterion("charge_payable_day_id >=", value, "chargePayableDayId");
            return (Criteria) this;
        }

        public Criteria andChargePayableDayIdLessThan(Long value) {
            addCriterion("charge_payable_day_id <", value, "chargePayableDayId");
            return (Criteria) this;
        }

        public Criteria andChargePayableDayIdLessThanOrEqualTo(Long value) {
            addCriterion("charge_payable_day_id <=", value, "chargePayableDayId");
            return (Criteria) this;
        }

        public Criteria andChargePayableDayIdIn(List<Long> values) {
            addCriterion("charge_payable_day_id in", values, "chargePayableDayId");
            return (Criteria) this;
        }

        public Criteria andChargePayableDayIdNotIn(List<Long> values) {
            addCriterion("charge_payable_day_id not in", values, "chargePayableDayId");
            return (Criteria) this;
        }

        public Criteria andChargePayableDayIdBetween(Long value1, Long value2) {
            addCriterion("charge_payable_day_id between", value1, value2, "chargePayableDayId");
            return (Criteria) this;
        }

        public Criteria andChargePayableDayIdNotBetween(Long value1, Long value2) {
            addCriterion("charge_payable_day_id not between", value1, value2, "chargePayableDayId");
            return (Criteria) this;
        }

        public Criteria andCollectionOrderSnIsNull() {
            addCriterion("collection_order_sn is null");
            return (Criteria) this;
        }

        public Criteria andCollectionOrderSnIsNotNull() {
            addCriterion("collection_order_sn is not null");
            return (Criteria) this;
        }

        public Criteria andCollectionOrderSnEqualTo(String value) {
            addCriterion("collection_order_sn =", value, "collectionOrderSn");
            return (Criteria) this;
        }

        public Criteria andCollectionOrderSnNotEqualTo(String value) {
            addCriterion("collection_order_sn <>", value, "collectionOrderSn");
            return (Criteria) this;
        }

        public Criteria andCollectionOrderSnGreaterThan(String value) {
            addCriterion("collection_order_sn >", value, "collectionOrderSn");
            return (Criteria) this;
        }

        public Criteria andCollectionOrderSnGreaterThanOrEqualTo(String value) {
            addCriterion("collection_order_sn >=", value, "collectionOrderSn");
            return (Criteria) this;
        }

        public Criteria andCollectionOrderSnLessThan(String value) {
            addCriterion("collection_order_sn <", value, "collectionOrderSn");
            return (Criteria) this;
        }

        public Criteria andCollectionOrderSnLessThanOrEqualTo(String value) {
            addCriterion("collection_order_sn <=", value, "collectionOrderSn");
            return (Criteria) this;
        }

        public Criteria andCollectionOrderSnLike(String value) {
            addCriterion("collection_order_sn like", value, "collectionOrderSn");
            return (Criteria) this;
        }

        public Criteria andCollectionOrderSnNotLike(String value) {
            addCriterion("collection_order_sn not like", value, "collectionOrderSn");
            return (Criteria) this;
        }

        public Criteria andCollectionOrderSnIn(List<String> values) {
            addCriterion("collection_order_sn in", values, "collectionOrderSn");
            return (Criteria) this;
        }

        public Criteria andCollectionOrderSnNotIn(List<String> values) {
            addCriterion("collection_order_sn not in", values, "collectionOrderSn");
            return (Criteria) this;
        }

        public Criteria andCollectionOrderSnBetween(String value1, String value2) {
            addCriterion("collection_order_sn between", value1, value2, "collectionOrderSn");
            return (Criteria) this;
        }

        public Criteria andCollectionOrderSnNotBetween(String value1, String value2) {
            addCriterion("collection_order_sn not between", value1, value2, "collectionOrderSn");
            return (Criteria) this;
        }

        public Criteria andChargeStatusIsNull() {
            addCriterion("charge_status is null");
            return (Criteria) this;
        }

        public Criteria andChargeStatusIsNotNull() {
            addCriterion("charge_status is not null");
            return (Criteria) this;
        }

        public Criteria andChargeStatusEqualTo(Byte value) {
            addCriterion("charge_status =", value, "chargeStatus");
            return (Criteria) this;
        }

        public Criteria andChargeStatusNotEqualTo(Byte value) {
            addCriterion("charge_status <>", value, "chargeStatus");
            return (Criteria) this;
        }

        public Criteria andChargeStatusGreaterThan(Byte value) {
            addCriterion("charge_status >", value, "chargeStatus");
            return (Criteria) this;
        }

        public Criteria andChargeStatusGreaterThanOrEqualTo(Byte value) {
            addCriterion("charge_status >=", value, "chargeStatus");
            return (Criteria) this;
        }

        public Criteria andChargeStatusLessThan(Byte value) {
            addCriterion("charge_status <", value, "chargeStatus");
            return (Criteria) this;
        }

        public Criteria andChargeStatusLessThanOrEqualTo(Byte value) {
            addCriterion("charge_status <=", value, "chargeStatus");
            return (Criteria) this;
        }

        public Criteria andChargeStatusIn(List<Byte> values) {
            addCriterion("charge_status in", values, "chargeStatus");
            return (Criteria) this;
        }

        public Criteria andChargeStatusNotIn(List<Byte> values) {
            addCriterion("charge_status not in", values, "chargeStatus");
            return (Criteria) this;
        }

        public Criteria andChargeStatusBetween(Byte value1, Byte value2) {
            addCriterion("charge_status between", value1, value2, "chargeStatus");
            return (Criteria) this;
        }

        public Criteria andChargeStatusNotBetween(Byte value1, Byte value2) {
            addCriterion("charge_status not between", value1, value2, "chargeStatus");
            return (Criteria) this;
        }

        public Criteria andChargeUserIdIsNull() {
            addCriterion("charge_user_id is null");
            return (Criteria) this;
        }

        public Criteria andChargeUserIdIsNotNull() {
            addCriterion("charge_user_id is not null");
            return (Criteria) this;
        }

        public Criteria andChargeUserIdEqualTo(Long value) {
            addCriterion("charge_user_id =", value, "chargeUserId");
            return (Criteria) this;
        }

        public Criteria andChargeUserIdNotEqualTo(Long value) {
            addCriterion("charge_user_id <>", value, "chargeUserId");
            return (Criteria) this;
        }

        public Criteria andChargeUserIdGreaterThan(Long value) {
            addCriterion("charge_user_id >", value, "chargeUserId");
            return (Criteria) this;
        }

        public Criteria andChargeUserIdGreaterThanOrEqualTo(Long value) {
            addCriterion("charge_user_id >=", value, "chargeUserId");
            return (Criteria) this;
        }

        public Criteria andChargeUserIdLessThan(Long value) {
            addCriterion("charge_user_id <", value, "chargeUserId");
            return (Criteria) this;
        }

        public Criteria andChargeUserIdLessThanOrEqualTo(Long value) {
            addCriterion("charge_user_id <=", value, "chargeUserId");
            return (Criteria) this;
        }

        public Criteria andChargeUserIdIn(List<Long> values) {
            addCriterion("charge_user_id in", values, "chargeUserId");
            return (Criteria) this;
        }

        public Criteria andChargeUserIdNotIn(List<Long> values) {
            addCriterion("charge_user_id not in", values, "chargeUserId");
            return (Criteria) this;
        }

        public Criteria andChargeUserIdBetween(Long value1, Long value2) {
            addCriterion("charge_user_id between", value1, value2, "chargeUserId");
            return (Criteria) this;
        }

        public Criteria andChargeUserIdNotBetween(Long value1, Long value2) {
            addCriterion("charge_user_id not between", value1, value2, "chargeUserId");
            return (Criteria) this;
        }

        public Criteria andChargeCreatedAtIsNull() {
            addCriterion("charge_created_at is null");
            return (Criteria) this;
        }

        public Criteria andChargeCreatedAtIsNotNull() {
            addCriterion("charge_created_at is not null");
            return (Criteria) this;
        }

        public Criteria andChargeCreatedAtEqualTo(Date value) {
            addCriterion("charge_created_at =", value, "chargeCreatedAt");
            return (Criteria) this;
        }

        public Criteria andChargeCreatedAtNotEqualTo(Date value) {
            addCriterion("charge_created_at <>", value, "chargeCreatedAt");
            return (Criteria) this;
        }

        public Criteria andChargeCreatedAtGreaterThan(Date value) {
            addCriterion("charge_created_at >", value, "chargeCreatedAt");
            return (Criteria) this;
        }

        public Criteria andChargeCreatedAtGreaterThanOrEqualTo(Date value) {
            addCriterion("charge_created_at >=", value, "chargeCreatedAt");
            return (Criteria) this;
        }

        public Criteria andChargeCreatedAtLessThan(Date value) {
            addCriterion("charge_created_at <", value, "chargeCreatedAt");
            return (Criteria) this;
        }

        public Criteria andChargeCreatedAtLessThanOrEqualTo(Date value) {
            addCriterion("charge_created_at <=", value, "chargeCreatedAt");
            return (Criteria) this;
        }

        public Criteria andChargeCreatedAtIn(List<Date> values) {
            addCriterion("charge_created_at in", values, "chargeCreatedAt");
            return (Criteria) this;
        }

        public Criteria andChargeCreatedAtNotIn(List<Date> values) {
            addCriterion("charge_created_at not in", values, "chargeCreatedAt");
            return (Criteria) this;
        }

        public Criteria andChargeCreatedAtBetween(Date value1, Date value2) {
            addCriterion("charge_created_at between", value1, value2, "chargeCreatedAt");
            return (Criteria) this;
        }

        public Criteria andChargeCreatedAtNotBetween(Date value1, Date value2) {
            addCriterion("charge_created_at not between", value1, value2, "chargeCreatedAt");
            return (Criteria) this;
        }

        public Criteria andChargeUserNameIsNull() {
            addCriterion("charge_user_name is null");
            return (Criteria) this;
        }

        public Criteria andChargeUserNameIsNotNull() {
            addCriterion("charge_user_name is not null");
            return (Criteria) this;
        }

        public Criteria andChargeUserNameEqualTo(String value) {
            addCriterion("charge_user_name =", value, "chargeUserName");
            return (Criteria) this;
        }

        public Criteria andChargeUserNameNotEqualTo(String value) {
            addCriterion("charge_user_name <>", value, "chargeUserName");
            return (Criteria) this;
        }

        public Criteria andChargeUserNameGreaterThan(String value) {
            addCriterion("charge_user_name >", value, "chargeUserName");
            return (Criteria) this;
        }

        public Criteria andChargeUserNameGreaterThanOrEqualTo(String value) {
            addCriterion("charge_user_name >=", value, "chargeUserName");
            return (Criteria) this;
        }

        public Criteria andChargeUserNameLessThan(String value) {
            addCriterion("charge_user_name <", value, "chargeUserName");
            return (Criteria) this;
        }

        public Criteria andChargeUserNameLessThanOrEqualTo(String value) {
            addCriterion("charge_user_name <=", value, "chargeUserName");
            return (Criteria) this;
        }

        public Criteria andChargeUserNameLike(String value) {
            addCriterion("charge_user_name like", value, "chargeUserName");
            return (Criteria) this;
        }

        public Criteria andChargeUserNameNotLike(String value) {
            addCriterion("charge_user_name not like", value, "chargeUserName");
            return (Criteria) this;
        }

        public Criteria andChargeUserNameIn(List<String> values) {
            addCriterion("charge_user_name in", values, "chargeUserName");
            return (Criteria) this;
        }

        public Criteria andChargeUserNameNotIn(List<String> values) {
            addCriterion("charge_user_name not in", values, "chargeUserName");
            return (Criteria) this;
        }

        public Criteria andChargeUserNameBetween(String value1, String value2) {
            addCriterion("charge_user_name between", value1, value2, "chargeUserName");
            return (Criteria) this;
        }

        public Criteria andChargeUserNameNotBetween(String value1, String value2) {
            addCriterion("charge_user_name not between", value1, value2, "chargeUserName");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}